/***************************************************************************
    File                 : Style.cc
    Project              : LabPlot
    --------------------------------------------------------------------
    Copyright            : (C) 2008 by Stefan Gerlach, Alexander Semke
    Email (use @ for *)  : stefan.gerlach*uni-konstanz.de, alexander.semke*web.de
    Description          : plot style class
                           
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *  This program is free software; you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation; either version 2 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the Free Software           *
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor,                    *
 *   Boston, MA  02110-1301  USA                                           *
 *                                                                         *
 ***************************************************************************/
#include "Style.h"
#include <KDebug>

Style::Style(bool l, Style::StyleType type, QColor color, bool filled, QColor fillColor, int width, Qt::PenStyle penStyle, Qt::BrushStyle brushStyle)
{
	kDebug()<<"Style()"<<endl;
	m_type = type;
	m_lineEnabled=l;
	m_lineStyle = penStyle;
	m_lineColor = color;
	m_lineWidth=width;

	m_filled = filled;
	m_fillColor = fillColor;
	m_fillBrushStyle = brushStyle;

	m_boxWidth=10;
	m_autoBoxWidth=false;
	m_sortPoints=true;
}

Symbol* Style::symbol(){
	return &m_symbol;
}
/*
void Style::save(QTextStream *t) {
	*t<<type<<' '<<color.name()<<endl;
	*t<<fill<<' '<<fillcolor.name()<<endl;
	*t<<width<<' '<<penStyle<<' '<<brush<<endl;
	*t<<boxwidth<<' '<<autoboxwidth<<endl;
	*t<<sort_points<<endl;
}

int Style::open(QTextStream *t,int version) {
	kDebug()<<"Style::open()"<<endl;
	QString c;
	int graphtype, f, tmptype;

	*t>>graphtype>>tmptype>>c;
	type = (StylesType)tmptype;
	color=QColor(c);
	*t>>f>>c;
	fill= (bool)f;
	fillcolor=QColor(c);
	if (version>11)
		*t>>width>>penStyle>>brush;

	int e;
	if(version>18) {
		*t>>boxwidth>>e;
		autoboxwidth=(bool)e;
	}
	if(version>22) {
		*t>>e;
		sort_points = (bool)e;
	}

	return graphtype;
}

QDomElement Style::saveXML(QDomDocument doc) {
	QDomElement styletag = doc.createElement( "Style" );

	QDomElement tag = doc.createElement( "Type" );
	styletag.appendChild( tag );
	QDomText t = doc.createTextNode( QString::number(type) );
	tag.appendChild( t );
	tag = doc.createElement( "Color" );
	styletag.appendChild( tag );
	t = doc.createTextNode( color.name() );
	tag.appendChild( t );
	tag = doc.createElement( "Width" );
	styletag.appendChild( tag );
	t = doc.createTextNode( QString::number(width) );
	tag.appendChild( t );
	tag = doc.createElement( "Fill" );
	styletag.appendChild( tag );
	t = doc.createTextNode( QString::number(fill) );
	tag.appendChild( t );
	tag = doc.createElement( "FillColor" );
	styletag.appendChild( tag );
	t = doc.createTextNode( fillcolor.name() );
	tag.appendChild( t );
	tag = doc.createElement( "PenStyle" );
	styletag.appendChild( tag );
	t = doc.createTextNode( QString::number(penStyle) );
	tag.appendChild( t );
	tag = doc.createElement( "Brush" );
	styletag.appendChild( tag );
	t = doc.createTextNode( QString::number(brush) );
	tag.appendChild( t );
	tag = doc.createElement( "BoxWidth" );
	styletag.appendChild( tag );
	t = doc.createTextNode( QString::number(boxwidth) );
	tag.appendChild( t );
	tag = doc.createElement( "AutoBoxWidth" );
	styletag.appendChild( tag );
	t = doc.createTextNode( QString::number(autoboxwidth) );
	tag.appendChild( t );
	tag = doc.createElement( "SortPoints" );
	styletag.appendChild( tag );
	t = doc.createTextNode( QString::number(sort_points) );
	tag.appendChild( t );

	return styletag;
}

void Style::openXML(QDomNode node) {
	while(!node.isNull()) {
		QDomElement e = node.toElement();
//		kDebug()<<"STYLE TAG = "<<e.tagName()<<endl;
//		kDebug()<<"STYLE TEXT = "<<e.text()<<endl;

		if(e.tagName() == "Type")
			type = (StylesType) e.text().toInt();
		else if(e.tagName() == "Color")
			color = QColor(e.text());
		else if(e.tagName() == "Width")
			width = e.text().toInt();
		else if(e.tagName() == "Fill")
			fill = (bool) e.text().toInt();
		else if(e.tagName() == "FillColor")
			fillcolor = QColor(e.text());
		else if(e.tagName() == "PenStyle")
			penStyle = e.text().toInt();
		else if(e.tagName() == "Brush")
			brush = e.text().toInt();
		else if(e.tagName() == "BoxWidth")
			boxwidth = e.text().toInt();
		else if(e.tagName() == "AutoBoxWidth")
			autoboxwidth = (bool) e.text().toInt();
		else if(e.tagName() == "SortPoints")
			sort_points = (bool) e.text().toInt();

		node = node.nextSibling();
	}
}
*/
